import { system, world } from '@minecraft/server';

function durabilityOnChanged(item, player, isHitEntity = false) {
    let level = item.getComponent("minecraft:enchantable")?.getEnchantment("unbreaking")?.level;

    function durability() {
        let durability = item.getComponent("minecraft:durability");

        const t = Math.floor(Math.random() * 100);

        if (t < durability.getDamageChance()) {
            if (!isHitEntity) durability.damage += 1;
            if (durability.damage >= durability.maxDurability) {
                player.playSound("random.break");
                if (!isHitEntity) player.getComponent('equippable').setEquipment('Mainhand', undefined)
            } else {
                if (!isHitEntity) player.getComponent('equippable').setEquipment('Mainhand', item)
            }
        } else {
            if (!isHitEntity) return;
            durability.damage -= 1;
            if (!isHitEntity) player.getComponent('equippable').setEquipment('Mainhand', item);
        }
    }

    const t = Math.floor(Math.random() * 10)
    if (level === 1 && t > 8) return;
    else if (level === 2 && t > 6) return;
    else if (level === 3 && t > 4) return;
    else durability();
}

world.beforeEvents.worldInitialize.subscribe(initEvent => { initEvent.itemComponentRegistry.registerCustomComponent('kaz_baursak_abylai_khan:trigger', {
  onConsume: e => {
  e.source.addEffect("minecraft:absorption", 2400, {amplifier: 4});
e.source.addEffect("minecraft:fire_resistance", 6000, {amplifier: 1});
e.source.addEffect("minecraft:regeneration", 600, {amplifier: 2});
e.source.addEffect("minecraft:resistance", 6000, {amplifier: 1});
  
},

  
});

initEvent.itemComponentRegistry.registerCustomComponent('kaz_baursak_gold:trigger', {
  onConsume: e => {
  e.source.addEffect("minecraft:absorption", 2400, {amplifier: 1});
e.source.addEffect("minecraft:regeneration", 100, {amplifier: 2});
  
},

  
});

initEvent.itemComponentRegistry.registerCustomComponent('kaz_kazakh_chocolate:trigger', {
  onConsume: e => {
  e.source.addEffect("minecraft:speed", 600, {amplifier: 2});
  
},

  
});

initEvent.itemComponentRegistry.registerCustomComponent('kaz_dagger_abylai_khan:trigger', {
  
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('kaz_koktal:trigger', {
  onConsume: e => {
  e.source.addEffect("minecraft:regeneration", 200, {amplifier: 2});
  
},

  
});

initEvent.itemComponentRegistry.registerCustomComponent('kaz_kylysh:trigger', {
  
  
  onHitEntity: e => { durabilityOnChanged(e.itemStack, e.source, true); },
  onMineBlock: e => { durabilityOnChanged(e.itemStack, e.source, false); },
});

initEvent.itemComponentRegistry.registerCustomComponent('kaz_kumiss:trigger', {
  onConsume: e => {
  e.source.addEffect("minecraft:nausea", 100, {amplifier: 2});
e.source.removeEffect("minecraft:absorption");
e.source.removeEffect("minecraft:blindness");
e.source.removeEffect("minecraft:fatal_poison");
e.source.removeEffect("minecraft:haste");
e.source.removeEffect("minecraft:village_hero");
e.source.removeEffect("minecraft:invisibility");
e.source.removeEffect("minecraft:levitation");
e.source.removeEffect("minecraft:instant_damage");
e.source.removeEffect("minecraft:poison");
e.source.removeEffect("minecraft:resistance");
e.source.removeEffect("minecraft:slow_falling");
e.source.removeEffect("minecraft:water_breathing");
e.source.removeEffect("minecraft:speed");
e.source.removeEffect("minecraft:wither");
e.source.removeEffect("minecraft:weakness");
e.source.removeEffect("minecraft:strength");
e.source.removeEffect("minecraft:slowness");
e.source.removeEffect("minecraft:saturation");
e.source.removeEffect("minecraft:regeneration");
e.source.removeEffect("minecraft:night_vision");
e.source.removeEffect("minecraft:mining_fatigue");
e.source.removeEffect("minecraft:jump_boost");
e.source.removeEffect("minecraft:instant_health");
e.source.removeEffect("minecraft:hunger");
e.source.removeEffect("minecraft:health_boost");
e.source.removeEffect("minecraft:fire_resistance");
e.source.removeEffect("minecraft:conduit_power");
e.source.removeEffect("minecraft:bad_omen");
  
},

  
});

initEvent.itemComponentRegistry.registerCustomComponent('kaz_dombra:trigger', {
  onUse: e => { e.source.runCommand("function dombra_playsound"); },
});
 });
